import { buildUUID } from '../../../utils/uuid';
import { ApiActionPage } from '../../model/baseModel';
import { MesBomListItem, MesBomPageParams, MesBomPageListGetResultModel } from '../model/mesModel';
import { genAction, Api, genActionPage } from '../system';
import { defHttp } from '/@/utils/http/axios';
import { useUserStore } from '../../../store/modules/user';

/*
 * 获取产线分页列表
 */
export const getMesBomListByPage = async (params: MesBomPageParams) => {
  let sqlcmd = '';
  if (params?.MAT_ID != undefined && params?.MAT_ID != '') {
    sqlcmd += "And MAT_ID like '%" + params?.MAT_ID + "%'";
  }
  if (params?.PART_NO != undefined && params?.PART_NO != '') {
    sqlcmd += "And PART_NO like '%" + params?.PART_NO + "%'";
  }
  if (params?.PARENT_NO != undefined && params?.PARENT_NO != '') {
    sqlcmd += "And PARENT_NO like '%" + params?.PARENT_NO + "%'";
  }
  const rParams = genActionPage('MES_RULE', sqlcmd, params.page, params.pageSize);
  return getMesBomListByPageAsync(rParams);
};
async function getMesBomListByPageAsync(params: ApiActionPage) {
  //   const data = await defHttp.post<ApiActionPage>(
  //     { url: Api.EntityPageList, params },
  //     {
  //       isTransformResponse: false,
  //     },
  //   );
  const data: MesBomListItem[] = [
    {
      ID: '1',
      MAT_ID: 'P24A2AAH06C1151',
      PART_NO: 'P24A2AAH06C1151',
      SPART_NO: '',
      FACTORY_CODE: '002',
      QTY: '1',
      EFFDATE: '2023-03-06 00:32:48',
      PARENT_NO: 'P24A2AAH06C1151',
      PART_STATUS: 'Active',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      REMARK: '',
    },
    {
      ID: '2',
      MAT_ID: 'P24A2AAH06C1152',
      PART_NO: 'P24A2AAH06C1152',
      SPART_NO: '',
      FACTORY_CODE: '002',
      QTY: '1',
      EFFDATE: '2023-03-06 00:32:48',
      PARENT_NO: 'P24A2AAH06C1152',
      PART_STATUS: 'Active',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      REMARK: '',
    },
    {
      ID: '3',
      MAT_ID: 'P24A2AAH06C1153',
      PART_NO: 'P24A2AAH06C1153',
      SPART_NO: '',
      FACTORY_CODE: '002',
      QTY: '1',
      EFFDATE: '2023-03-06 00:32:48',
      PARENT_NO: 'P24A2AAH06C1153',
      PART_STATUS: 'Active',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      REMARK: '',
    },
    {
      ID: '4',
      MAT_ID: 'P24A2AAH06C1153',
      PART_NO: 'P24A2AAH06C1153',
      SPART_NO: '',
      FACTORY_CODE: '002',
      QTY: '1',
      EFFDATE: '2023-03-06 00:32:48',
      PARENT_NO: 'P24A2AAH06C1153',
      PART_STATUS: 'Active',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      REMARK: '',
    },
    {
      ID: '5',
      MAT_ID: 'P24A2AAH06C1153',
      PART_NO: 'P24A2AAH06C1153',
      SPART_NO: '',
      FACTORY_CODE: '002',
      QTY: '1',
      EFFDATE: '2023-03-06 00:32:48',
      PARENT_NO: 'P24A2AAH06C1153',
      PART_STATUS: 'Active',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      REMARK: '',
    },
  ];
  const model: MesBomPageListGetResultModel = {
    // items: data.Data.data,
    // total: data.Data.totals,
    items: data,
    total: data.length,
  };
  return model;
}
//保存
export const SaveBom = async (params: MesBomListItem, isUpdate: boolean) => {
  let data;
  if (isUpdate) {
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('MES_PROD_BOM', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    params.ID = buildUUID(); //生成GUID
    params.CREATE_USER = useUserStore().getUserInfo.userId;
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('MES_PROD_BOM', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  }
  return data;
};
//删除
export const DeleteBom = async (params: Recordable) => {
  const usParams = genAction('MES_PROD_BOM', [params]);
  return await defHttp.post(
    { url: Api.DeleteList, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
    },
  );
};
